/**********************************************************************************************
 *
 * This file declares the binomial transformer for computing per-set locality.
 * r' = r.B
 * B is a generalized stochastic Binomial matrix.
 * Ref: Equation 3, Case 1 (Section 3.1) in the paper.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#ifndef _BINOMIAL_H_
#define _BINOMIAL_H_

class per_set_locality_binomial_t {
private:
public:
    per_set_locality_binomial_t();
    void transform_r(double r[],double rB[],unsigned int r_size,unsigned int rBP_size,unsigned int num_diff_set_bits) const;
};

#endif

