/**********************************************************************************************
 *
 * This file defines constants used by predictors and needed for sizing arrays.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#ifndef _COMMON_H_
#define _COMMON_H_

// If you change the cache parameters, you may also need to modify other files, e.g.,
//     pred_mr.cpp: setting minA[], maxA[], printing miss-ratios
//     pred_plru.cpp: \phi is implemented only up to A'=32

#define MAX_INDEX_BITS 18                 // max #sets=2^18, see Table 1
#define MIN_INDEX_BITS 10                 // min #sets=2^10, see Table 1
#define MAX_DIFF_SET_BITS (MAX_INDEX_BITS-MIN_INDEX_BITS)
#define MAX_ASSOC 32                      // max associativity=32-way, see Table 1
#define MAX_R_SRC_SIZE 512                // r(2^10) is needed for 512 positions, see Section 3.2. Reduce this value to see the effect of truncation.
#define MAX_R_TGT_SIZE (2*MAX_ASSOC)      // r' is maintained for 2A' positions, see Section 4

#endif

