/**********************************************************************************************
 *
 * This file implements functions that read r and compute d.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "util.h"

const unsigned int max_size=(1<<19);      /* URDs range from 0 to max_size-1 */
double r[max_size];
double d[max_size];

void init() {
    unsigned int i;
    for(i=0;i<max_size;i++) {
        r[i]=0;
        d[i]=0;
    }
}

void print_d(unsigned int actual_size) {
    unsigned int i;
    for(i=0;i<actual_size;i++) {
        printf("%d %g\n",i,d[i]);
    }
}

int main() {
    init();
    const char *file_path="example_r_S1.txt";
    unsigned int actual_size=read_urd(file_path,r,max_size);
    compute_d(r,d,actual_size);
    print_d(actual_size);
    return 0;
}

