/**********************************************************************************************
 *
 * This example shows how to invoke the miss ratio predictors.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include "pred_lru.h"
#include "pred_plru.h"
#include "pred_random.h"
#include "pred_nmru.h"

int main(int argc, char *argv[]) {
    pred_mr_t *pred_mr;
    if(argc!=2) {
        printf("Usage: %s <[LRU/PLRU/RANDOM/NMRU]>\n",argv[0]);
        printf("Example: %s LRU\n",argv[0]);
        return -1;
    }
    if(!strcmp(argv[1],"LRU")) pred_mr=new pred_lru_t;
    else if(!strcmp(argv[1],"PLRU")) pred_mr=new pred_plru_t;
    else if(!strcmp(argv[1],"RANDOM")) pred_mr=new pred_random_t;
    else if(!strcmp(argv[1],"NMRU")) pred_mr=new pred_nmru_t;
    else assert(0);

    pred_mr->read_r_src("example_r_S1024.txt");
    pred_mr->compute_miss_ratio();
    pred_mr->print_miss_ratio();

    // IMPORTANT: call pred_mr->reset() before processing the next distribution

    return 0;
}

