/**********************************************************************************************
 *
 * This file implements the child predictor class for LRU.
 * Ref: Section 4.1 in the paper.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#include "pred_lru.h"

pred_lru_t::pred_lru_t() {
    reset();
}

void pred_lru_t::reset() {
    pred_mr_t::reset();
}

double pred_lru_t::compute_miss_ratio_specific(unsigned int num_diff_set_bits,unsigned int assoc) {
    unsigned int j;
    double p=0;
    // \phi(LRU) is a step function; this is taken care of by the for loop
    for(j=0;j<assoc;j++) {
        p+=r_tgt[num_diff_set_bits][j];
    }
    return 1-p;
}

