/**********************************************************************************************
 *
 * This file declares the child predictor class for RANDOM.
 * Ref: Section 4.2 in the paper.
 *
 * Author: Rathijit Sen 
 *         University of Wisconsin-Madison
 *         rathijit@cs.wisc.edu
 *
 **********************************************************************************************/

#ifndef _RANDOM_H_
#define _RANDOM_H

#include "pred_mr.h"

class pred_random_t: public pred_mr_t{
private:
    double phi[2*MAX_ASSOC];
    double d_tgt[MAX_DIFF_SET_BITS+1][MAX_R_TGT_SIZE];  // d_tgt[x] holds d corresponding to r(S'=2^(x+MIN_INDEX_BITS)), where x=num_diff_set_bits
    bool d_computed[MAX_DIFF_SET_BITS+1];               // book-keeping to track that d_tgt for the same target configuration is not computed multipled times
public:
    pred_random_t();
    void reset();
    double compute_miss_ratio_specific(unsigned int num_diff_set_bits,unsigned int assoc);
}; 

#endif
